## direwolf 1.2

=== Makefile ===
# Select proper Makefile for operating system.
# The Windows version is built with the help of Cygwin. 

win := $(shell uname | grep CYGWIN)
ifneq ($(win),)
include Makefile.win
else
include Makefile.linux
endif

## direwolf 1.0

=== debian/changelog ===
direwolf (1.0-2) unstable; urgency=medium

  * No longer install the ll2utm or utm2ll binaries or man pages. (Closes:
    #768223)

 -- Iain R. Learmonth <irl@fsfe.org>  Fri, 07 Nov 2014 13:40:27 +0000

direwolf (1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #759639)

 -- Iain R. Learmonth <irl@fsfe.org>  Sat, 11 Oct 2014 18:54:51 +0100

=== debian/control ===
Source: direwolf
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Iain R. Learmonth <irl@fsfe.org>
Build-Depends: debhelper (>= 9), libasound2-dev
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-hamradio/direwolf.git/
Vcs-Git: git://anonscm.debian.org/pkg-hamradio/direwolf.git
Homepage: http://home.comcast.net/~wb2osz/site/

Package: direwolf
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, direwolf-docs
Description: Soundcard TNC for APRS
 Dire Wolf is a software "soundcard" modem/TNC and APRS encoder/decoder. It can
 be used stand-alone to receive APRS messages, as a digipeater, APRStt gateway,
 or Internet Gateway (IGate). It can also be used as a virtual TNC for other
 applications such as APRSIS32, UI-View32, Xastir, APRS-TW, YAAC, UISS, Linux
 AX25, SARTrack, and many others.

Package: direwolf-docs
Architecture: all
Section: doc
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Soundcard TNC for APRS - Documentation
 Dire Wolf is a software "soundcard" modem/TNC and APRS encoder/decoder. It can
 be used stand-alone to receive APRS messages, as a digipeater, APRStt gateway,
 or Internet Gateway (IGate). It can also be used as a virtual TNC for other
 applications such as APRSIS32, UI-View32, Xastir, APRS-TW, YAAC, UISS, Linux
 AX25, SARTrack, and many others.
 .
 This package contains architecture independent documentation for direwolf.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make -f Makefile.linux

override_dh_auto_install:
	make -f Makefile.linux install

override_dh_auto_clean:
	make -f Makefile.linux clean
	-rm aclients gen_fff

## direwolf 1.1

=== debian/changelog ===
direwolf (1.1-2) unstable; urgency=medium

  * Added a Breaks+Replaces as files have moved between packages. (Closes:
    #777674)

 -- Iain R. Learmonth <irl@fsfe.org>  Wed, 11 Feb 2015 14:52:06 +0000

direwolf (1.1-1) unstable; urgency=medium

  * Update to new upstream version 1.1.

 -- Iain R. Learmonth <irl@fsfe.org>  Thu, 05 Feb 2015 00:32:28 +0000

direwolf (1.0-3) unstable; urgency=medium

  * Changes architecture for direwolf from linux-any to a whitelist of
    little-endian architectures. (Closes: #774389)

 -- Iain R. Learmonth <irl@fsfe.org>  Tue, 20 Jan 2015 05:32:05 +0000

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,18 @@
 Priority: optional
 Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
 Uploaders: Iain R. Learmonth <irl@fsfe.org>
-Build-Depends: debhelper (>= 9), libasound2-dev
+Build-Depends: debhelper (>= 9), libasound2-dev, libgps-dev
 Standards-Version: 3.9.6
 Vcs-Browser: http://anonscm.debian.org/cgit/pkg-hamradio/direwolf.git/
 Vcs-Git: git://anonscm.debian.org/pkg-hamradio/direwolf.git
 Homepage: http://home.comcast.net/~wb2osz/site/
 
 Package: direwolf
-Architecture: linux-any
+Architecture: alpha amd64 arm64 armel armhf i386 mipsel ppc64el sh4 x32
 Depends: ${shlibs:Depends}, ${misc:Depends}, direwolf-docs
+Suggests: gpsd
+Breaks: direwolf-docs (<< 1.1-1)
+Replaces: direwolf-docs (<< 1.1-1)
 Description: Soundcard TNC for APRS
  Dire Wolf is a software "soundcard" modem/TNC and APRS encoder/decoder. It can
  be used stand-alone to receive APRS messages, as a digipeater, APRStt gateway,
@@ -23,6 +26,8 @@
 Architecture: all
 Section: doc
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Breaks: direwolf (<< 1.1-1)
+Replaces: direwolf (<< 1.1-1)
 Description: Soundcard TNC for APRS - Documentation
  Dire Wolf is a software "soundcard" modem/TNC and APRS encoder/decoder. It can
  be used stand-alone to receive APRS messages, as a digipeater, APRStt gateway,

## direwolf 1.2

=== debian/changelog ===
direwolf (1.2-2build1) xenial; urgency=medium

  * No-change rebuild for libgps transition.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 09 Feb 2016 10:32:52 +0000

direwolf (1.2-2) unstable; urgency=medium

  * Allow building with gpsd API major version 6 (Closes: #803686)
   - Thanks Bas Couwenberg!
  * debian/control:
   - Updated my email address in uploaders.

 -- Iain R. Learmonth <irl@debian.org>  Mon, 02 Nov 2015 14:15:36 +0000

direwolf (1.2-1) unstable; urgency=medium

  * Update to new upstream version 1.2.
  * Microsoft Word sources for PDF files:
    - Added:
      * A-Better-APRS-Packet-Demodulator-Part-1-1200-baud.docx
      * A-Better-APRS-Packet-Demodulator-Part-2-9600-baud.docx
    - Updated:
      * APRStt-Implementation-Notes.docx
      * Raspberry-Pi-APRS-Tracker.docx
      * Raspberry-Pi-APRS.docx
      * User-Guide.docx
    - Removed:
      * Quick-Start-Guide-Windows.docx
  * debian/source/include-binaries:
    - Allowed inclusion of new Microsoft Word sources and removed the removed
      source.
  * man pages:
    - Dire Wolf now ships with its own man pages, using the upstream man pages
      instead of the man pages created for Debian.
  * debian/rules:
    - Installation is now performed using dh instead of using the Makefile
  * debian/direwolf-docs.doc-base:
    - PDFs are now installed under the direwolf-docs doc directory
  * debian/direwolf.examples:
    - Installs the example direwolf.conf
  * Refreshed patches:
    - fix_documentation_path.patch (de-fuzz)
    - enable_gps.patch (de-fuzz)
    - fix_hardening-no-relro.patch (now adding LDFLAGS to CFLAGS instead of
      passing LDFLAGS on every CC call)
    - fix_spelling.patch (multiple new spelling fixes)
  * debian/copyright:
    - Dire Wolf now includes some code copied from geotranz

 -- Iain R. Learmonth <irl@fsfe.org>  Sat, 13 Jun 2015 19:58:02 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: hamradio
 Priority: optional
 Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
-Uploaders: Iain R. Learmonth <irl@fsfe.org>
+Uploaders: Iain R. Learmonth <irl@debian.org>
 Build-Depends: debhelper (>= 9), libasound2-dev, libgps-dev
 Standards-Version: 3.9.6
 Vcs-Browser: http://anonscm.debian.org/cgit/pkg-hamradio/direwolf.git/

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make -f Makefile.linux

override_dh_auto_install:
	@echo "Skipping the install to /usr/local"

override_dh_auto_clean:
	make -f Makefile.linux clean

override_dh_fixperms:
	dh_fixperms
	chmod 644 debian/direwolf/usr/share/direwolf/dw-icon.png

=== debian/watch ===
version=3

http://home.comcast.net/~wb2osz/site/?/page/Download/ http://home.comcast.net/~wb2osz/.*/direwolf-([\d\.]+)-src.zip

## direwolf 1.3

=== debian/changelog ===
direwolf (1.3-2) unstable; urgency=medium

  * Team upload
  * Added systemd service file (Closes: #808827) 

 -- Ana Custura <ana@netstat.org.uk>  Sun, 18 Sep 2016 14:24:50 +0100

direwolf (1.3-1) unstable; urgency=medium

  * New upstream version
  * Updated watch file to use GitHub releases
  * debian/patches:
   - Removed libgps22.patch (fixed upstream)
   - Removed enable_gps.patch (fixed upstream)
   - Removed fix_start_script_paths.patch (fixed upstream)
   - Refreshed fix_spelling.patch (de-fuzz; submitted upstream)
   - Refreshed fix_hardening-no-relro.patch (de-fuzz; submitted upstream)
   - Refreshed fix_documentation_path.patch (de-fuzz)
  * debian/source/include-binaries:
   - New Word document sources added for the PDF documentation:
     + debian/APRStt-Listening-Example.docx
     + debian/A-Closer-Look-at-the-WA8LMF-TNC-Test-CD.docx
     + debian/APRS-Telemetry-Toolkit.docx
     + debian/APRStt-interface-for-SARTrack.docx
     + debian/Raspberry-Pi-SDR-IGate.docx
  * debian/control:
   - Updated Homepage
   - Updated Vcs-* URIs to secure versions
  * debian/rules:
   - Enable all hardening options in the build
   - Remove gen_fff and direwolf.conf in clean target (Closes: #819384)

 -- Iain R. Learmonth <irl@debian.org>  Tue, 05 Jul 2016 22:14:07 +0100

direwolf (1.2-3) unstable; urgency=medium

  * Allow for building only architecture-independent packages (Closes: #806015)
   - Thanks Santiago Vila!

 -- Iain R. Learmonth <irl@debian.org>  Fri, 08 Apr 2016 21:40:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,22 @@
 Source: direwolf
+Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
+Uploaders: Iain R. Learmonth <irl@debian.org>
 Section: hamradio
 Priority: optional
-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
-Uploaders: Iain R. Learmonth <irl@debian.org>
-Build-Depends: debhelper (>= 9), libasound2-dev, libgps-dev
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-hamradio/direwolf.git/
-Vcs-Git: git://anonscm.debian.org/pkg-hamradio/direwolf.git
-Homepage: http://home.comcast.net/~wb2osz/site/
+Build-Depends: debhelper (>= 9),
+               libasound2-dev,
+               libgps-dev,
+	       dh-systemd
+Standards-Version: 3.9.8
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hamradio/direwolf.git/
+Vcs-Git: https://anonscm.debian.org/git/pkg-hamradio/direwolf.git
+Homepage: https://github.com/wb2osz/direwolf
 
 Package: direwolf
 Architecture: alpha amd64 arm64 armel armhf i386 mipsel ppc64el sh4 x32
-Depends: ${shlibs:Depends}, ${misc:Depends}, direwolf-docs
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         direwolf-docs
 Suggests: gpsd
 Breaks: direwolf-docs (<< 1.1-1)
 Replaces: direwolf-docs (<< 1.1-1)
@@ -25,7 +30,8 @@
 Package: direwolf-docs
 Architecture: all
 Section: doc
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends},
+         ${misc:Depends}
 Breaks: direwolf (<< 1.1-1)
 Replaces: direwolf (<< 1.1-1)
 Description: Soundcard TNC for APRS - Documentation
@@ -36,4 +42,3 @@
  AX25, SARTrack, and many others.
  .
  This package contains architecture independent documentation for direwolf.
-

=== debian/watch ===
version=3
https://github.com/wb2osz/direwolf/releases .*/archive/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## direwolf 1.4+dfsg

=== debian/changelog ===
direwolf (1.4+dfsg-1build1) bionic; urgency=medium

  * No-change rebuild against libgps23

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 03 Nov 2017 19:03:17 +0000

direwolf (1.4+dfsg-1) unstable; urgency=medium

  * New upstream version 1.4+dfsg
  * The direwolf-docs binary package has been removed:
   - This package depended on sources for the documentation being provided
     by the author. For this release, it has not been possible to obtain
     these sources and they have never been included in the releases directly.
  * debian/control:
   - Updated standards version to 4.1.0
   - Removed direwolf-docs binary package
   - Added dependency on adduser, used by new scripts below
  * debian/copyright:
   - Refreshed to reflect moved files
   - Added files to exclude for DFSG repack (the PDF documentation)
  * debian/watch:
   - use dversionmangle to remove dfsg before comparison
  * debian/post{inst,rm}:
   - New scripts create user and group used by the systemd service file if not
     present (Closes: #855497)

 -- Iain R. Learmonth <irl@debian.org>  Fri, 15 Sep 2017 07:39:43 +0100

=== debian/control ===
Source: direwolf
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Iain R. Learmonth <irl@debian.org>
Section: hamradio
Priority: optional
Build-Depends: debhelper (>= 9),
               libasound2-dev,
               libgps-dev,
	       dh-systemd
Standards-Version: 4.1.0
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hamradio/direwolf.git/
Vcs-Git: https://anonscm.debian.org/git/pkg-hamradio/direwolf.git
Homepage: https://github.com/wb2osz/direwolf

Package: direwolf
Architecture: alpha amd64 arm64 armel armhf i386 mipsel ppc64el sh4 x32
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser
Suggests: gpsd
Breaks: direwolf-docs (<< 1.1-1)
Replaces: direwolf-docs (<< 1.1-1)
Description: Soundcard TNC for APRS
 Dire Wolf is a software "soundcard" modem/TNC and APRS encoder/decoder. It can
 be used stand-alone to receive APRS messages, as a digipeater, APRStt gateway,
 or Internet Gateway (IGate). It can also be used as a virtual TNC for other
 applications such as APRSIS32, UI-View32, Xastir, APRS-TW, YAAC, UISS, Linux
 AX25, SARTrack, and many others.

=== debian/watch ===
version=3
opts=dversionmangle=s/\.dfsg// \
https://github.com/wb2osz/direwolf/releases .*/archive/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## direwolf 1.5%2Bdfsg

=== debian/changelog ===
direwolf (1.5+dfsg-4build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 10:57:53 +0000

direwolf (1.5+dfsg-4build1) focal; urgency=medium

  * No-change rebuild against libgps26.

 -- Rik Mills <rikmills@kde.org>  Mon, 13 Jan 2020 10:46:37 +0000

direwolf (1.5+dfsg-4) unstable; urgency=medium

  * Adds the audio supplemental group to the systemd service unit to allow the
    use of the sound card when running as a system service

 -- Iain R. Learmonth <irl@debian.org>  Fri, 22 Nov 2019 16:48:53 +0000

direwolf (1.5+dfsg-3) unstable; urgency=medium

  [ Bernd Zeimetz ]
  * Don't be strict about the GPSD API (Closes: #926549)

  [ Iain R. Learmonth ]
  * d/control: Standards version to 4.4.1

 -- Iain R. Learmonth <irl@debian.org>  Mon, 28 Oct 2019 19:01:15 +0000

direwolf (1.5+dfsg-2) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * Adds compatibility for newer GPSD versions (Closes: #926549)

  [ Iain R. Learmonth ]
  * Adds support for hamlib rig control
    - New build dependency libhamlib-dev

 -- Iain R. Learmonth <irl@debian.org>  Tue, 09 Jul 2019 09:51:48 +0100

direwolf (1.5+dfsg-1) experimental; urgency=medium

  * New upstream version 1.5+dfsg
  * debian/control:
   - Removed obsolete build dependency on dh-systemd
   - Updated Vcs-* fields for salsa
   - Updated Standards Version to 4.3.0
   - Added adduser to and removed direwolf-docs from
     dependencies for direwolf
  * debian/patches:
   - Refreshed patches
  * debian/compat:
   - Level bumped to 12
  * debian/rules:
   - Use dh_installsystemd
  * debian/copyright:
   - Use https URL for format link

 -- Iain R. Learmonth <irl@debian.org>  Mon, 10 Jun 2019 18:48:29 +0100

## direwolf 1.5+dfsg

=== Makefile ===
# Select proper Makefile for operating system.
# The Windows version is built with the help of Cygwin. 

# In my case, I see CYGWIN_NT-6.1-WOW so we don't check for 
# equal to some value.   Your mileage my vary.

win := $(shell uname | grep CYGWIN)
dar := $(shell uname | grep Darwin)

ifneq ($(win),)
   include Makefile.win
else ifeq ($(dar),Darwin)
   include Makefile.macosx
else
   include Makefile.linux
endif

=== debian/changelog ===
direwolf (1.5+dfsg-4~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 03 Sep 2020 00:53:17 -0400

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: direwolf
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
 XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
 Uploaders: Iain R. Learmonth <irl@debian.org>
 Section: hamradio
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 12),
                libasound2-dev,
                libgps-dev,
-	       dh-systemd
-Standards-Version: 4.1.0
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hamradio/direwolf.git/
-Vcs-Git: https://anonscm.debian.org/git/pkg-hamradio/direwolf.git
+               libhamlib-dev,
+               adduser
+Standards-Version: 4.4.1
+Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/direwolf
+Vcs-Git: https://salsa.debian.org/debian-hamradio-team/direwolf.git
 Homepage: https://github.com/wb2osz/direwolf
 
 Package: direwolf

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_build:
	make -f Makefile.linux

override_dh_installinit:
	dh_installinit --no-start --noscripts
override_dh_auto_install:
	@echo "Skipping the install to /usr/local"

override_dh_auto_clean:
	make -f Makefile.linux clean
	-rm gen_fff
	-rm direwolf.conf

override_dh_fixperms-arch:
	dh_fixperms
	chmod 644 debian/direwolf/usr/share/direwolf/dw-icon.png

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

## direwolf 1.6%2Bdfsg

=== conf/CMakeLists.txt ===
# generate conf per platform
file(READ "${CUSTOM_CONF_DIR}/generic.conf" file_content)

if(LINUX)
  string(REGEX REPLACE "\n%W%[^\n]*" "" file_content "${file_content}")
  string(REGEX REPLACE "\n%M%[^\n]*" "" file_content "${file_content}")
  string(REGEX REPLACE "\n%L%([^\n]*)" "\n\\1" file_content "${file_content}")
elseif(WIN32 OR CYGWIN)
  string(REGEX REPLACE "\n%M%[^\n]*" "" file_content "${file_content}")
  string(REGEX REPLACE "\n%L%[^\n]*" "" file_content "${file_content}")
  string(REGEX REPLACE "\n%W%([^\n]*)" "\n\\1" file_content "${file_content}")
else() # macOS FreeBSD OpenBSD
  string(REGEX REPLACE "\n%W%[^\n]*" "" file_content "${file_content}")
  string(REGEX REPLACE "\n%L%[^\n]*" "" file_content "${file_content}")
  string(REGEX REPLACE "\n%M%([^\n]*)" "\n\\1" file_content "${file_content}")
endif()

# remove remark
string(REGEX REPLACE "\n%R%[^\n]*" "" file_content "${file_content}")

# clear common lines
string(REGEX REPLACE "\n%C%([^\n]*)" "\n\\1" file_content "${file_content}")
string(REGEX REPLACE "^%C%([^\n]*)" "\\1" file_content "${file_content}")

file(WRITE "${CMAKE_BINARY_DIR}/direwolf.conf" "${file_content}")

# install udev rules for CM108
if(LINUX)
  install(FILES "${CUSTOM_CONF_DIR}/99-direwolf-cmedia.rules" DESTINATION /etc/udev/rules.d/)
endif()

install(FILES "${CMAKE_BINARY_DIR}/direwolf.conf" DESTINATION ${INSTALL_CONF_DIR})
install(FILES "${CUSTOM_CONF_DIR}/sdr.conf" DESTINATION ${INSTALL_CONF_DIR})

# Put sample configuration & startup files in home directory.
# This step would be done as ordinary user.
# Some people like to put the direwolf config file in /etc/ax25.
# Note that all of these are also in $(DESTDIR)/share/doc/direwolf/examples/.
if(NOT (WIN32 OR CYGWIN))
  add_custom_target(install-conf
    COMMAND ${CMAKE_COMMAND}
    -DCUSTOM_BINARY_DIR="${CMAKE_BINARY_DIR}"
    -DCUSTOM_CONF_DIR="${CUSTOM_CONF_DIR}"
    -DCUSTOM_SCRIPTS_DIR="${CUSTOM_SCRIPTS_DIR}"
    -DCUSTOM_TELEMETRY_DIR="${CUSTOM_TELEMETRY_DIR}"
    -P "${CMAKE_SOURCE_DIR}/conf/install_conf.cmake"
    )
endif()

=== data/CMakeLists.txt ===
#
# The destination field is often used to identify the manufacturer/model.
# These are not hardcoded into Dire Wolf.  Instead they are read from
# a file called tocalls.txt at application start up time.
#
# The original permanent symbols are built in but the "new" symbols,
# using overlays, are often updated.  These are also read from files.
#
# You can obtain an updated copy by typing "make data-update".
# This is not part of the normal build process.  You have to do this explicitly.
#
# The locations below appear to be the most recent.
# The copy at http://www.aprs.org/tocalls.txt is out of date.
#

include(ExternalProject)

set(TOCALLS_TXT "tocalls.txt")
set(TOCALLS_TXT_BKP "tocalls.txt.old")
set(TOCALLS_URL "http://www.aprs.org/aprs11/tocalls.txt")
set(SYMBOLS-NEW_TXT "symbols-new.txt")
set(SYMBOLS-NEW_TXT_BKP "symbols-new.txt.old")
set(SYMBOLS-NEW_URL "http://www.aprs.org/symbols/symbols-new.txt")
set(SYMBOLSX_TXT "symbolsX.txt")
set(SYMBOLSX_TXT_BKP "symbolsX.txt.old")
set(SYMBOLSX_URL "http://www.aprs.org/symbols/symbolsX.txt")
set(CUSTOM_BINARY_DATA_DIR "${CMAKE_BINARY_DIR}/data")

# we can also move to a separate cmake file and use file(download)
# see conf/install_conf.cmake as example
file(COPY "${CUSTOM_DATA_DIR}/${TOCALLS_TXT}" DESTINATION "${CUSTOM_BINARY_DATA_DIR}")
file(COPY "${CUSTOM_DATA_DIR}/${SYMBOLS-NEW_TXT}" DESTINATION "${CUSTOM_BINARY_DATA_DIR}")
file(COPY "${CUSTOM_DATA_DIR}/${SYMBOLSX_TXT}" DESTINATION "${CUSTOM_BINARY_DATA_DIR}")

add_custom_target(data_rename
  COMMAND ${CMAKE_COMMAND} -E rename "${CUSTOM_BINARY_DATA_DIR}/${TOCALLS_TXT}" "${CUSTOM_BINARY_DATA_DIR}/${TOCALLS_TXT_BKP}"
  COMMAND ${CMAKE_COMMAND} -E rename "${CUSTOM_BINARY_DATA_DIR}/${SYMBOLS-NEW_TXT}" "${CUSTOM_BINARY_DATA_DIR}/${SYMBOLS-NEW_TXT_BKP}"
  COMMAND ${CMAKE_COMMAND} -E rename "${CUSTOM_BINARY_DATA_DIR}/${SYMBOLSX_TXT}" "${CUSTOM_BINARY_DATA_DIR}/${SYMBOLSX_TXT_BKP}"
  )

ExternalProject_Add(download_tocalls
  DEPENDS data_rename
  URL ${TOCALLS_URL}
  PREFIX ""
  DOWNLOAD_DIR "${CUSTOM_BINARY_DATA_DIR}"
  DOWNLOAD_NAME "${TOCALLS_TXT}"
  DOWNLOAD_NO_EXTRACT 0
  EXCLUDE_FROM_ALL 1
  UPDATE_COMMAND ""
  PATCH_COMMAND ""
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  TEST_COMMAND ""
  )

ExternalProject_Add(download_symbols-new
  DEPENDS data_rename
  URL ${SYMBOLS-NEW_URL}
  PREFIX ""
  DOWNLOAD_DIR "${CUSTOM_BINARY_DATA_DIR}"
  DOWNLOAD_NAME "${SYMBOLS-NEW_TXT}"
  DOWNLOAD_NO_EXTRACT 0
  EXCLUDE_FROM_ALL 1
  UPDATE_COMMAND ""
  PATCH_COMMAND ""
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  TEST_COMMAND ""
  )

ExternalProject_Add(download_symbolsx
  DEPENDS data_rename
  URL ${SYMBOLSX_URL}
  PREFIX ""
  DOWNLOAD_DIR "${CUSTOM_BINARY_DATA_DIR}"
  DOWNLOAD_NAME "${SYMBOLSX_TXT}"
  DOWNLOAD_NO_EXTRACT 0
  EXCLUDE_FROM_ALL 1
  UPDATE_COMMAND ""
  PATCH_COMMAND ""
  CONFIGURE_COMMAND ""
  BUILD_COMMAND ""
  INSTALL_COMMAND ""
  TEST_COMMAND ""
  )

add_custom_target(update-data)
add_dependencies(update-data data_rename download_tocalls download_symbols-new download_symbolsx)

install(FILES "${CUSTOM_BINARY_DATA_DIR}/${TOCALLS_TXT}" DESTINATION ${INSTALL_DATA_DIR})
install(FILES "${CUSTOM_BINARY_DATA_DIR}/${SYMBOLS-NEW_TXT}" DESTINATION ${INSTALL_DATA_DIR})
install(FILES "${CUSTOM_BINARY_DATA_DIR}/${SYMBOLSX_TXT}" DESTINATION ${INSTALL_DATA_DIR})

=== test/CMakeLists.txt ===
# This is a trick to avoid more complication
# because configure_file() is done at configuration time

set(CUSTOM_TEST_BINARY_DIR "${CMAKE_BINARY_DIR}/test")
set(GEN_PACKETS_BIN "${CMAKE_BINARY_DIR}/src/gen_packets${CMAKE_EXECUTABLE_SUFFIX}")
set(ATEST_BIN "${CMAKE_BINARY_DIR}/src/atest${CMAKE_EXECUTABLE_SUFFIX}")
set(FXSEND_BIN "${CMAKE_BINARY_DIR}/test/fxsend${CMAKE_EXECUTABLE_SUFFIX}")
set(FXREC_BIN "${CMAKE_BINARY_DIR}/test/fxrec${CMAKE_EXECUTABLE_SUFFIX}")

if(WIN32)
  set(CUSTOM_SCRIPT_SUFFIX ".bat")
else()
  set(CUSTOM_SCRIPT_SUFFIX "")
endif()

set(TEST_CHECK-FX25_FILE "check-fx25")
set(TEST_CHECK-MODEM1200_FILE "check-modem1200")
set(TEST_CHECK-MODEM300_FILE "check-modem300")
set(TEST_CHECK-MODEM9600_FILE "check-modem9600")
set(TEST_CHECK-MODEM19200_FILE "check-modem19200")
set(TEST_CHECK-MODEM2400-a_FILE "check-modem2400-a")
set(TEST_CHECK-MODEM2400-b_FILE "check-modem2400-b")
set(TEST_CHECK-MODEM2400-g_FILE "check-modem2400-g")
set(TEST_CHECK-MODEM4800_FILE "check-modem4800")

# generate the scripts that run the tests

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-FX25_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-FX25_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM1200_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM1200_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM300_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM9600_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM9600_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM19200_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM19200_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM2400-a_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM2400-a_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM2400-b_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM2400-b_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM2400-g_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM2400-g_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )

configure_file(
  "${CUSTOM_TEST_SCRIPTS_DIR}/${TEST_CHECK-MODEM4800_FILE}"
  "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM4800_FILE}${CUSTOM_SCRIPT_SUFFIX}"
  @ONLY
  )


# global includes
# not ideal but not so slow
# otherwise use target_include_directories
include_directories(
  ${CUSTOM_SRC_DIR}
  ${GPSD_INCLUDE_DIRS}
  ${HAMLIB_INCLUDE_DIRS}
  ${ALSA_INCLUDE_DIRS}
  ${UDEV_INCLUDE_DIRS}
  ${PORTAUDIO_INCLUDE_DIRS}
  ${CUSTOM_GEOTRANZ_DIR}
  ${CMAKE_BINARY_DIR}/src
  )

if(WIN32 OR CYGWIN)
  include_directories(
    ${CUSTOM_REGEX_DIR}
  )
endif()

# Why is there a special atest9 instead of using the normal one?

# Unit test for demodulators
list(APPEND atest9_SOURCES
  ${CUSTOM_SRC_DIR}/atest.c
  ${CUSTOM_SRC_DIR}/ais.c
  ${CUSTOM_SRC_DIR}/demod.c
  ${CUSTOM_SRC_DIR}/dsp.c
  ${CUSTOM_SRC_DIR}/demod_afsk.c
  ${CUSTOM_SRC_DIR}/demod_psk.c
  ${CUSTOM_SRC_DIR}/demod_9600.c
  ${CUSTOM_SRC_DIR}/fx25_extract.c
  ${CUSTOM_SRC_DIR}/fx25_init.c
  ${CUSTOM_SRC_DIR}/fx25_rec.c
  ${CUSTOM_SRC_DIR}/hdlc_rec.c
  ${CUSTOM_SRC_DIR}/hdlc_rec2.c
  ${CUSTOM_SRC_DIR}/multi_modem.c
  ${CUSTOM_SRC_DIR}/rrbb.c
  ${CUSTOM_SRC_DIR}/fcs_calc.c
  ${CUSTOM_SRC_DIR}/ax25_pad.c
  ${CUSTOM_SRC_DIR}/decode_aprs.c
  ${CUSTOM_SRC_DIR}/dwgpsnmea.c
  ${CUSTOM_SRC_DIR}/dwgps.c
  ${CUSTOM_SRC_DIR}/dwgpsd.c
  ${CUSTOM_SRC_DIR}/serial_port.c
  ${CUSTOM_SRC_DIR}/latlong.c
  ${CUSTOM_SRC_DIR}/symbols.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  ${CUSTOM_SRC_DIR}/telemetry.c
  ${CUSTOM_SRC_DIR}/dtime_now.c
  ${CUSTOM_SRC_DIR}/tt_text.c
  )

if(WIN32 OR CYGWIN)
  list(REMOVE_ITEM atest9_SOURCES
    ${CUSTOM_SRC_DIR}/dwgpsd.c
    )
endif()

add_executable(atest9
  ${atest9_SOURCES}
  )

target_link_libraries(atest9
  ${MISC_LIBRARIES}
  ${REGEX_LIBRARIES}
  ${GPSD_LIBRARIES}
  Threads::Threads
  )

if(WIN32 OR CYGWIN)
  set_target_properties(atest9
    PROPERTIES COMPILE_FLAGS "-DUSE_REGEX_STATIC"
    )
  target_link_libraries(atest9 ws2_32)
endif()


# Unit test for inner digipeater algorithm
list(APPEND dtest_SOURCES
  ${CUSTOM_SRC_DIR}/digipeater.c
  ${CUSTOM_SRC_DIR}/ais.c
  ${CUSTOM_SRC_DIR}/dedupe.c
  ${CUSTOM_SRC_DIR}/pfilter.c
  ${CUSTOM_SRC_DIR}/ax25_pad.c
  ${CUSTOM_SRC_DIR}/fcs_calc.c
  ${CUSTOM_SRC_DIR}/tq.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  ${CUSTOM_SRC_DIR}/decode_aprs.c
  ${CUSTOM_SRC_DIR}/dwgpsnmea.c
  ${CUSTOM_SRC_DIR}/dwgps.c
  ${CUSTOM_SRC_DIR}/dwgpsd.c
  ${CUSTOM_SRC_DIR}/serial_port.c
  ${CUSTOM_SRC_DIR}/latlong.c
  ${CUSTOM_SRC_DIR}/telemetry.c
  ${CUSTOM_SRC_DIR}/symbols.c
  ${CUSTOM_SRC_DIR}/tt_text.c
  )

if(WIN32 OR CYGWIN)
  list(REMOVE_ITEM dtest_SOURCES
    ${CUSTOM_SRC_DIR}/dwgpsd.c
    )
endif()

add_executable(dtest
  ${dtest_SOURCES}
  )

set_target_properties(dtest
  PROPERTIES COMPILE_FLAGS "-DDIGITEST -DUSE_REGEX_STATIC"
  )

target_link_libraries(dtest
  ${MISC_LIBRARIES}
  ${REGEX_LIBRARIES}
  ${GPSD_LIBRARIES}
  Threads::Threads
  )

if(WIN32 OR CYGWIN)
  target_link_libraries(dtest ws2_32)
endif()


# Unit test for APRStt tone seqence parsing.
list(APPEND ttest_SOURCES
  ${CUSTOM_SRC_DIR}/aprs_tt.c
  ${CUSTOM_SRC_DIR}/tt_text.c
  ${CUSTOM_SRC_DIR}/latlong.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(ttest
  ${ttest_SOURCES}
  )

set_target_properties(ttest
  PROPERTIES COMPILE_FLAGS "-DTT_MAIN"
  )

target_link_libraries(ttest
  ${MISC_LIBRARIES}
  ${GEOTRANZ_LIBRARIES}
  )


# Unit test for APRStt tone sequence / text conversions.
list(APPEND tttexttest_SOURCES
  ${CUSTOM_SRC_DIR}/tt_text.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(tttexttest
  ${tttexttest_SOURCES}
  )

set_target_properties(tttexttest
  PROPERTIES COMPILE_FLAGS "-DTTT_TEST"
  )

target_link_libraries(tttexttest
  ${MISC_LIBRARIES}
  )


# Unit test for Packet Filtering.
list(APPEND pftest_SOURCES
  ${CUSTOM_SRC_DIR}/pfilter.c
  ${CUSTOM_SRC_DIR}/ais.c
  ${CUSTOM_SRC_DIR}/ax25_pad.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  ${CUSTOM_SRC_DIR}/fcs_calc.c
  ${CUSTOM_SRC_DIR}/decode_aprs.c
  ${CUSTOM_SRC_DIR}/dwgpsnmea.c
  ${CUSTOM_SRC_DIR}/dwgps.c
  ${CUSTOM_SRC_DIR}/dwgpsd.c
  ${CUSTOM_SRC_DIR}/serial_port.c
  ${CUSTOM_SRC_DIR}/latlong.c
  ${CUSTOM_SRC_DIR}/symbols.c
  ${CUSTOM_SRC_DIR}/telemetry.c
  ${CUSTOM_SRC_DIR}/tt_text.c
  )

if(WIN32 OR CYGWIN)
  list(REMOVE_ITEM pftest_SOURCES
    ${CUSTOM_SRC_DIR}/dwgpsd.c
    )
endif()

add_executable(pftest
  ${pftest_SOURCES}
  )

set_target_properties(pftest
  PROPERTIES COMPILE_FLAGS "-DPFTEST -DUSE_REGEX_STATIC"
  )

target_link_libraries(pftest
  ${MISC_LIBRARIES}
  ${REGEX_LIBRARIES}
  ${GPSD_LIBRARIES}
  Threads::Threads
  )

if(WIN32 OR CYGWIN)
  target_link_libraries(pftest ws2_32)
endif()

# Unit test for telemetry decoding.
list(APPEND tlmtest_SOURCES
  ${CUSTOM_SRC_DIR}/telemetry.c
  ${CUSTOM_SRC_DIR}/ax25_pad.c
  ${CUSTOM_SRC_DIR}/fcs_calc.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

if(WIN32 OR CYGWIN)
  list(REMOVE_ITEM tlmtest_SOURCES
    ${CUSTOM_SRC_DIR}/dwgpsd.c
    )
endif()

add_executable(tlmtest
  ${tlmtest_SOURCES}
  )

set_target_properties(tlmtest
  PROPERTIES COMPILE_FLAGS "-DTEST -DUSE_REGEX_STATIC"
  )

target_link_libraries(tlmtest
  ${MISC_LIBRARIES}
  ${REGEX_LIBRARIES}
  )

if(WIN32 OR CYGWIN)
  target_link_libraries(tlmtest ws2_32)
endif()


# Unit test for location coordinate conversion.
list(APPEND lltest_SOURCES
  ${CUSTOM_SRC_DIR}/latlong.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(lltest
  ${lltest_SOURCES}
  )

set_target_properties(lltest
  PROPERTIES COMPILE_FLAGS "-DLLTEST"
  )

target_link_libraries(lltest
  ${MISC_LIBRARIES}
  )


# Unit test for encoding position & object report.
list(APPEND enctest_SOURCES
  ${CUSTOM_SRC_DIR}/encode_aprs.c
  ${CUSTOM_SRC_DIR}/latlong.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(enctest
  ${enctest_SOURCES}
  )

set_target_properties(enctest
  PROPERTIES COMPILE_FLAGS "-DEN_MAIN"
  )

target_link_libraries(enctest
  ${MISC_LIBRARIES}
  )


# Unit test for KISS encapsulation.
list(APPEND kisstest_SOURCES
  ${CUSTOM_SRC_DIR}/kiss_frame.c
  )

add_executable(kisstest
  ${kisstest_SOURCES}
  )

set_target_properties(kisstest
  PROPERTIES COMPILE_FLAGS "-DKISSTEST"
  )


# Unit test for constructing frames besides UI.
list(APPEND pad2test_SOURCES
  ${CUSTOM_SRC_DIR}/ax25_pad2.c
  ${CUSTOM_SRC_DIR}/ax25_pad.c
  ${CUSTOM_SRC_DIR}/fcs_calc.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(pad2test
  ${pad2test_SOURCES}
  )

set_target_properties(pad2test
  PROPERTIES COMPILE_FLAGS "-DPAD2TEST -DUSE_REGEX_STATIC"
  )

target_link_libraries(pad2test
  ${MISC_LIBRARIES}
  ${REGEX_LIBRARIES}
  )

if(WIN32 OR CYGWIN)
  target_link_libraries(pad2test ws2_32)
endif()


# Unit Test for XID frame encode/decode.
list(APPEND xidtest_SOURCES
  ${CUSTOM_SRC_DIR}/xid.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(xidtest
  ${xidtest_SOURCES}
  )

set_target_properties(xidtest
  PROPERTIES COMPILE_FLAGS "-DXIDTEST"
  )

target_link_libraries(xidtest
  ${MISC_LIBRARIES}
  )


# Unit Test for DTMF encode/decode.
list(APPEND dtmftest_SOURCES
  ${CUSTOM_SRC_DIR}/dtmf.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(dtmftest
  ${dtmftest_SOURCES}
  )

set_target_properties(dtmftest
  PROPERTIES COMPILE_FLAGS "-DDTMF_TEST"
  )

# Unit Test FX.25 algorithm.

list(APPEND fxsend_SOURCES
  ${CUSTOM_SRC_DIR}/fx25_send.c
  ${CUSTOM_SRC_DIR}/fx25_encode.c
  ${CUSTOM_SRC_DIR}/fx25_init.c
  ${CUSTOM_SRC_DIR}/fcs_calc.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(fxsend
  ${fxsend_SOURCES}
  )

set_target_properties(fxsend
  PROPERTIES COMPILE_FLAGS "-DFXTEST"
  )

list(APPEND fxrec_SOURCES
  ${CUSTOM_SRC_DIR}/fx25_rec.c
  ${CUSTOM_SRC_DIR}/fx25_extract.c
  ${CUSTOM_SRC_DIR}/fx25_init.c
  ${CUSTOM_SRC_DIR}/fcs_calc.c
  ${CUSTOM_SRC_DIR}/textcolor.c
  )

add_executable(fxrec
  ${fxrec_SOURCES}
  )

set_target_properties(fxrec
  PROPERTIES COMPILE_FLAGS "-DFXTEST"
  )


# doing ctest on previous programs

add_test(dtest dtest)
add_test(ttest ttest)
add_test(tttexttest tttexttest)
add_test(pftest pftest)
add_test(tlmtest tlmtest)
add_test(lltest lltest)
add_test(enctest enctest)
add_test(kisstest kisstest)
add_test(pad2test pad2test)
add_test(xidtest xidtest)
add_test(dtmftest dtmftest)

add_test(check-fx25 "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-FX25_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem1200 "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM1200_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem300 "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM300_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem9600 "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM9600_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem19200 "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM19200_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem2400-a "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM2400-a_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem2400-b "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM2400-b_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem2400-g "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM2400-g_FILE}${CUSTOM_SCRIPT_SUFFIX}")
add_test(check-modem4800 "${CUSTOM_TEST_BINARY_DIR}/${TEST_CHECK-MODEM4800_FILE}${CUSTOM_SCRIPT_SUFFIX}")

# TODO  miss the audio file
# ./atest9 -B 9600 ../walkabout9600.wav | grep "packets decoded in" >atest.out


#  -----------------------------  Manual tests and experiments  ---------------------------
if(OPTIONAL_TEST)

  # Unit test for IGate
  list(APPEND itest_SOURCES
    ${CUSTOM_SRC_DIR}/igate.c
    ${CUSTOM_SRC_DIR}/ais.c
    ${CUSTOM_SRC_DIR}/ax25_pad.c
    ${CUSTOM_SRC_DIR}/fcs_calc.c
    ${CUSTOM_SRC_DIR}/mheard.c
    ${CUSTOM_SRC_DIR}/pfilter.c
    ${CUSTOM_SRC_DIR}/telemetry.c
